// C Source File
// Created 8/21/2001; 2:12:25 PM
#include "declarations.h"
void loghand (void)
{
	ESI ptr, exact, approx;
	HANDLE dialoghandle = H_NULL, popuphandle = H_NULL;
	short extrawidth, stringlength, result, width, bottom, top;
	char rawvalues[40] = {};
	char* bvalue, *nvalue, *evalue;
	enum {LOGB = 1, LOGN, LOGE};
	short lcd_width = LCD_WIDTH, ti92plus = (TI92PLUS || V200);
	if (TI89)
	{
		extrawidth = 0;
	}
	else
	{
		extrawidth = 10;
	}
	popuphandle = PopupNew ("Solve for", 0);
	FontSetSys (F_6x8);
	WinClr (DeskTop);
	stringlength = DrawStrWidth ("logbn=e", F_6x8);
	DrawStr ((lcd_width - stringlength)/2, 20, "log n=e", A_REPLACE);
	DrawStr ((lcd_width - stringlength)/2 + 18, 24, "b", A_NORMAL);
	PopupAddText (popuphandle, -1, "b", LOGB);
	PopupAddText (popuphandle, -1, "n", LOGN);
	PopupAddText (popuphandle, -1, "e", LOGE);
	dialoghandle = DialogNewSimple (125 + 4 * extrawidth, 44 + extrawidth);
	DialogAddTitle (dialoghandle, "Enter values", BT_OK, BT_CANCEL);
	result = PopupDo (popuphandle, CENTER, 34, 0);
	HeapFree (popuphandle);
	popuphandle = H_NULL;
	switch (result)//b ^ e = n
	{
	case (LOGB):
		DialogAddRequest (dialoghandle, 3, 14, "n=", 0, 19, 8);
		DialogAddRequest (dialoghandle, 3, 24 + 2 * ti92plus, "e=", 20, 19, 8);
		if (DialogDo (dialoghandle, CENTER, 34, rawvalues, NULL) == KEY_ENTER)
		{
			nvalue = rawvalues;
			evalue = rawvalues + 20;
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;

			//push_END_TAG();
			push_longint ((long)1);
			push_parse_text (evalue);
			push_quantum (DIV_TAG);
			push_parse_text (nvalue);
			push_quantum (POW_TAG);

			ptr = top_estack;
			NG_rationalESI (ptr);
			exact = top_estack;
			NG_approxESI (ptr);
			approx = top_estack;

			WinClr (DeskTop);

			Parms2D (Parse2DExpr (exact, TRUE), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

			ngetchx();
			WinClr (DeskTop);

			Parms2D (Parse2DExpr (approx, TRUE), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

			ST_helpMsg ("Store ans to history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
  			saveResult (exact, exact - ptr, approx, approx - exact);
		}
		else
		{
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;
		}
		break;
	case (LOGN):
		DialogAddRequest (dialoghandle, 3, 14, "b=", 0, 19, 8);
		DialogAddRequest (dialoghandle, 3, 24 + 2 * ti92plus, "e=", 20, 39, 8);
		if (DialogDo (dialoghandle, CENTER, 34, rawvalues, NULL) == KEY_ENTER)
		{
			bvalue = rawvalues;
			evalue = rawvalues + 20;
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;

			//push_END_TAG();
			push_parse_text (evalue);
			push_parse_text (bvalue);
			push_quantum (POW_TAG);

			ptr = top_estack;
			NG_rationalESI (ptr);
			exact = top_estack;
			NG_approxESI (ptr);
			approx = top_estack;

			WinClr (DeskTop);

			Parms2D (Parse2DExpr (exact, TRUE), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
			Print2DExpr (top_estack, DeskTop, (lcd_width - width) / 2, 18 + top);

			ngetchx();
			WinClr (DeskTop);

			Parms2D (Parse2DExpr (approx, TRUE), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
			Print2DExpr (top_estack, DeskTop, (lcd_width - width) / 2, 18 + top);

			ST_helpMsg ("Store ans to history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
  			saveResult (exact, exact - ptr, approx, approx - exact);
		}
		else
		{
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;
		}
		break;
	case (LOGE):
		DialogAddRequest (dialoghandle, 3, 14, "b=", 0, 19, 8);
		DialogAddRequest (dialoghandle, 3, 24 + 2 * ti92plus, "n=", 20, 39, 8);
		if (DialogDo (dialoghandle, CENTER, 34, rawvalues, NULL) == KEY_ENTER)
		{
			bvalue = rawvalues;
			nvalue = rawvalues + 20;
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;

			//push_END_TAG();
			push_parse_text (nvalue);
			push_quantum (LN_TAG);
			push_parse_text (bvalue);
			push_quantum_pair (LN_TAG, DIV_TAG);

			ptr = top_estack;
			NG_rationalESI (ptr);
			exact = top_estack;
			NG_approxESI (ptr);
			approx = top_estack;

			WinClr (DeskTop);

			Parms2D (Parse2DExpr (exact, TRUE), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

			ngetchx();
			WinClr (DeskTop);

			Parms2D (Parse2DExpr (approx, TRUE), &width, &bottom, &top);
			if (width > lcd_width || top + bottom > DeskTop->Client.xy.y1 - DeskTop->Client.xy.y0)
			{
				ST_helpMsg ("Can't display result. Stored to history");
				ngetchx();
				saveResult (exact, exact - ptr, approx, approx - exact);
				return;
			}
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 18 + top);

			ST_helpMsg ("Store ans to history? Enter=Yes");
  		if (ngetchx() == KEY_ENTER)
  			saveResult (exact, exact - ptr, approx, approx - exact);
		}
		else
		{
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;
		}
		break;
	}
	if (popuphandle)
	{
		HeapFree (popuphandle);
		popuphandle = H_NULL;
	}
	if (dialoghandle)
	{
		HeapFree (dialoghandle);
		dialoghandle = H_NULL;
	}
}
