// C Source File
// Created 8/13/2001; 2:43:51 PM
//Mathh v5.00 by Joel Thompson
/*Version History:
8/13/01: Project started
v.2b 8/15/01 Variations finished
v.4b 8/18/01 Parabolas finished
v.5b 8/18/01 Pythagorean Theorem Finished
v.7b 8/19/01 Lines Finished
v.79b 8/21/01 Pascal's Triangle finished, just some problems with calling it
v.99b 8/21/01 Logs finished. Made all pushed vars volatile.
v1.0b 8/22.01 Figured out how to make Pascal's Triangle not crash. Made the
	vars global, ititalized them all to 0, made prog >24k.
v1.0 8/22/01 Made all vars local except the int array result. If local, prog
	crashes:( Although all the uncompressed sizes are over 24k, compressed sizes
	are still within about 20k of having result local :)
v1.1 8/23/01 First publically released version. Checked to see if the
	requested row was in the range for the storage array.
v1.2 8/25/01 Second publically released version. Made the result array local,
	allocated space with malloc (so enough size), and saved about 69 bytes in
	compressed state.
v1.5 9/2/01 Publically released. Changed int* result to unsigned long *result,
	used var_name_tag in variations for cosmetic changes; no more x = ... Also,
	version number in intro fixed.
v2.0 9/11/01 Publically released. Fixed bug which crashed when Pascal's
	triangle row was used. Some added macro __VEROFPROGRAM__
v3.0 3/23/02 Publically released. Implemented new argument engine so you can
	pass anything to a dialog box (except Pascal's triangle), and it will take
	it as an argument. Nothing else new, but that took a while. Yeah, this prog
	was laying dormant on my HD for about 6 months before I did anything with
	it, but I finally got (probably) the best improvement made.
v3.5 3/29/02 Publically Releasesd. Added some code to make sure the handles
	got freed, and changed the display routine in slope.
v3.60 3/31/02 Publically Released. I tried to find where I did something like
	push_quantum (x); push_quantum (y); and changed it to
	push_quantum_pair (x,y);.Changed the code a	little to accomodate a longer
	__VEROFPROGRAM__ macro and center it more. I also did some changes, instead
	of using the pseudo-constants LCD_WIDTH	and TI92PLUS, I made little vars for
	them to try to make program shorter. Added some comments to the source in
	the little start-up animation.
v4.00 4/23/02 Publically Released. First, and most important, I added the
	series stuff. You can find the nth term of an arithmetic or geometric
	sequence, find the sum of n terms of an arithmetic or geometric series, or
	find the sum of an infinite geometric series. Note: if r >= 1, the result
	will be infinity. Also, I changed the code around a bit. Instead of arrays
	for the individual results from dialogs, they are now pointers to the
	correct spot in the original arry. This (hopefully) saves a bit of memory
	and time. I also upped the max number of characters that can be entered from
	8 to 19. Also, in TIGCC v.94B13, POW_TAG has been left out of the Tags Enum;
	to fix this, I added the last 3 lines of declerations.h
v4.50 11/28/02 Publically Released. Added some stuff to the series menu: You
	can now find what n, r, and d are from knowledge of the other variable. Also
	added #define SET_FILE_IN_USE_BIT b/c this program uses dialog boxes which
	call the event loop which deletes the launcher's twin symbol if the launcher
	was archived. Changed all int's to short's. Added support (theoretically)
	for the V200. Used #define ENABLE_ERROR_RETURN instead of the try blocks.
	Fixed spelling of declarations
v5.00 8/1/03 Publically Released. Added option to store result in home screen history, with exact as entry
 and approx as answer. Also, if the result was too big to display, automatically store in home screen
 history. Removed check for no slope (ie, a vertical line) b/c 1: The check as written was buggy, and
 2: Division by 0 results in "undef" which suits our purposes.
 Major code improvements (I've learned a lot about C and TIGCC since starting this project).
 Now uses F-line ROM calls for size purposes with an internal F-line emulator to maintain compatibility
 AMS 1.01*/
//main file, to get input on what to do, pass to right function

#include "declarations.h"//has globals, includes tigcclib.h.
void _main(void)
{
	LCD_BUFFER buffer;
	short lcd_width = LCD_WIDTH, ti92plus = (TI92PLUS || V200);
	unsigned x, y, z, result, stringlength, totalstringlength;
	char *variations[] = {"Variations", "Direct", "Inverse", "Joint",//2
		"Combined"};//set up menu items
	char *parabolas[] = {"Parabolas", "X-intercept", "Vertex"};//4
	char *pythag[] = {"Pythag", "a", "c"};//5
	char *lines[] = {"Lines", "Slope", "Distance", "Midpoint", "Convert",//7
		"Equation"};
	char *pascal[] = {"Pascal"};//8
	char *logs[] = {"Logs"};//10
	char *series[] = {"Series", "Arithmetic", "Geometric"};
	HANDLE menuhandle = MenuNew (2, lcd_width, 18), exec_handle;//make handles
	OSSetSR (0x0700);//turn off interrupts, enter screen faster, no kbd queue
	x = 0;//menunew is for the size
	y = 0;
	ClrScr();
	FontSetSys (ti92plus);//if 89, then ti92 is false or 0, which is F_4x6, on
	totalstringlength = DrawStrWidth ("Welcome to "__VEROFPROGRAM__, ti92plus);
	stringlength = DrawStrWidth ("Welcome to ", ti92plus);
	//totalstringlength is total length of the welcome to mathh vX.XX,
	//stringlength is length of "Welcome to " string.
	//(lcd_width - stringlength)/2 is my starting position for the string, b/c
	//say lcd_width = 100 and totalstringlength = 50.
	//(lcd_width - totalstringlength)/2 = (100 - 50)/2 = 25. There are 25 on
	// each side so it is centered. I don't care about the y value here.
	for (x = 0, y = 0; x < (lcd_width - totalstringlength)/2; x++, y++)
	{//begining animation
		DrawStr (x, y, "Welcome to ", A_XOR);//xor so second will dissapear
		DrawStr (x, y, "Welcome to ", A_XOR);//to make it disappear
	}
	//because it dissapeared....
	DrawStr (x, y, "Welcome to ", A_XOR);//make one so it stays
	z = y;
	//here, (lcd_width - totalstringlength)/2 + stringlength is where I want to
	//be. I take the starting position and add the length of the text on the
	//screen (stringlength) to get it where I want it. I add y because I want to
	//go in a 45 degree angle, so if I add y, it will go y down and left to
	//where I want it.
	for (x = (lcd_width - totalstringlength)/2 + stringlength + y, y = 0;
		y != z; y++, x--)
	{
		DrawStr (x, y, __VEROFPROGRAM__, A_XOR);
		DrawStr (x, y, __VEROFPROGRAM__, A_XOR);
	}
	DrawStr (x, y, __VEROFPROGRAM__, A_XOR);
	stringlength = DrawStrWidth ("By Joel Thompson", ti92plus);
	DrawStr ((short)((lcd_width - stringlength)/2), y + 10, "By Joel Thompson",
		A_REPLACE);
	MenuAddText (menuhandle, 0, variations[0], 0, 0);//set up menu text, args
	MenuAddText (menuhandle, 0, parabolas[0], 0, 0);//are: handle from menunew,
	MenuAddText (menuhandle, 0, pythag[0], 0, 0);//link code,
	MenuAddText (menuhandle, 0, lines[0], 0, 0);//text,
	MenuAddText (menuhandle, -1, pascal[0], 0, 0);//and flags
	MenuAddText (menuhandle, -1, logs[0], 0, 0);
	MenuAddText (menuhandle, 0, series[0], 0, 0);
	for (x = 1; x < 5; x++)//set up submenu items
	{
		MenuAddText (menuhandle, 1, variations[x], 0, 0);
	}
	for (x = 1; x < 3; x++)
	{
		MenuAddText (menuhandle, 2, parabolas[x], 0, 0);
	}
	for (x = 1; x < 3; x++)
	{
		MenuAddText (menuhandle, 3, pythag[x], 0, 0);
	}
	for (x = 1; x < 6; x++)
	{
		MenuAddText (menuhandle, 4, lines[x], 0, 0);
	}
	for (x = 1; x < 3; x++)
	{
		MenuAddText (menuhandle, 7, series[x], 0, 0);
	}
	exec_handle = MenuBegin (HLock (menuhandle), 0, 0, 0);//create handle,
	while ((x = ngetchx()) != KEY_ESC)
	{
		#ifndef DISP_RESULT
		OSDisableBreak();
		#endif
		result = MenuKey (exec_handle, x);
		#ifndef DISP_RESULT
		ST_refDsp (1);
		ST_busy (ST_NORMAL);
		LCD_save (buffer);
		FontSetSys (ti92plus);
		if ((result >= DIRECT) && (result <= COMBINED))//if in variations
		{
			varhand (result);
		}
		else if ((result >= X_ICEPT) && (result <= VERTEX))//esleif quadratics
		{
			parabhand (result, buffer);
		}
		else if ((result >= PYTHA) && (result <= PYTHC))
		{
			pythaghand (result);
		}
		else if ((result >= SLOPE) && (result <= EQUATION))
		{
			linehand (result);
		}
		else if (result == LOGS)
		{
			loghand();
		}
		else if (result == PASCAL)
		{
			pascalhand();
		}
		else if (result == ARITHMETIC || result == GEOMETRIC)
		{
			serhand (result);
		}
		LCD_restore (buffer);
		#else
		printf ("result = %i", result);
		#endif
	}
	//SetIntVec (AUTO_INT_1, old_int_1);
	HeapUnlock (menuhandle);
	HeapFree (menuhandle);
	MenuEnd (exec_handle);
	MenuUpdate();
	OSClearBreak();
	OSEnableBreak();
	push_whole_string ("Made By Joel Thompson");
}

BOOL saveResult (ESI exact, short exactSize, ESI approx, short approxSize)
{
	HANDLE exacthandle, approxhandle;
	unsigned char* ptr;

	exacthandle = HeapAlloc (exactSize + 3);
	if (!exacthandle)
		return FALSE;

	approxhandle = HeapAlloc (approxSize + 3);
  if (!approxhandle)
  {
  	HeapFree (exacthandle);
  	return FALSE;
  }

  ptr = HeapDeref (exacthandle);
  *(unsigned short*)ptr = exactSize + 1;
  ptr[2] = ENDSTACK_TAG;
  memmove (ptr + 3, exact - exactSize + 1, exactSize);

  ptr = HeapDeref (approxhandle);
  *(unsigned short*)ptr = approxSize + 1;
  ptr[2] = ENDSTACK_TAG;
  memmove (ptr + 3, approx - approxSize + 1, approxSize);

  HomeStorePair(exacthandle, approxhandle);
  return TRUE;
}

#if 0
void _main (void)
{
	LCD_BUFFER buffer;
	LCD_save (buffer);
	TRY//to protect program and restore the screen contents if there is an error
		real_main();//in the program that results in a dialog, if not,then status
	ONERR//line would be trash. Call real_main() in try block, if error, go here
		LCD_restore (buffer);//restore the screen
		PASS;//result of program, pass on the error to default, as if no try block
	ENDTRY//but still screen results here
	LCD_restore (buffer);
	push_whole_string ("Made by Joel Thompson");//push string
}
#endif